--
-- EquipCompare localization information
--
-- Contents:
-- * Localized versions of item names that are not available by default from Blizzard
-- * Usage information
-- * Cosmos labels and information
-- * Miscellaneous labels
--
-- Supported languages:
-- English, French, German (partial)
--

-- "Bonus" inventory types - these must be matched to the text in-game if you are translating
if (GetLocale() == "zhCN") then
	EQUIPCOMPARE_INVTYPE_WAND = "魔杖";
	EQUIPCOMPARE_INVTYPE_GUN = "枪械";
	EQUIPCOMPARE_INVTYPE_GUNPROJECTILE = "弹药";
	EQUIPCOMPARE_INVTYPE_BOWPROJECTILE = "弹药";

	EQUIPCOMPARE_BIGFOOT_ITEM = "自动比较装备"

	-- Misc labels
	EQUIPCOMPARE_EQUIPPED_LABEL = "|cffff00ff目前装备|r";
elseif (GetLocale() == "zhTW") then
	EQUIPCOMPARE_INVTYPE_WAND = "魔杖";
	EQUIPCOMPARE_INVTYPE_GUN = "槍械";
	EQUIPCOMPARE_INVTYPE_GUNPROJECTILE = "彈藥";
	EQUIPCOMPARE_INVTYPE_BOWPROJECTILE = "彈藥";

	EQUIPCOMPARE_BIGFOOT_ITEM = "自動比較裝備"

	-- Misc labels
	EQUIPCOMPARE_EQUIPPED_LABEL = "|cffff00ff目前裝備|r";
else
	EQUIPCOMPARE_INVTYPE_WAND = "Wand";
	EQUIPCOMPARE_INVTYPE_GUN = "Gun";
	EQUIPCOMPARE_INVTYPE_GUNPROJECTILE = "Projectile";
	EQUIPCOMPARE_INVTYPE_BOWPROJECTILE = "Projectile";

	EQUIPCOMPARE_BIGFOOT_ITEM = "Equip Compare"

	-- Misc labels
	EQUIPCOMPARE_EQUIPPED_LABEL = "|cffff00ffCurrent Equipment|r";
end

--
-- Post-localization processing
--
if (not INVTYPE_WAND) then INVTYPE_WAND = EQUIPCOMPARE_INVTYPE_WAND end;
if (not INVTYPE_GUN) then INVTYPE_GUN = EQUIPCOMPARE_INVTYPE_GUN end;
if (not INVTYPE_GUNPROJECTILE) then INVTYPE_GUNPROJECTILE = EQUIPCOMPARE_INVTYPE_GUNPROJECTILE end;
if (not INVTYPE_BOWPROJECTILE) then INVTYPE_BOWPROJECTILE = EQUIPCOMPARE_INVTYPE_BOWPROJECTILE end;
