--[[

	Name:		MobHealth2
	Version:	2.61
	Author:		Wyv (wyv@wp.pl)
	Description:	Displays health value for mobs.
			Original version by Telo.
	URL:		http://www.curse-gaming.com/mod.php?addid=1087
			http://ui.worldofwar.net/ui.php?id=681
			http://www.wowinterface.com/downloads/fileinfo.php?id=3938
	Modify:Zeg 2006-3-24 ngacn.com

]]


-- Current target data
local lTargetData;

-- table of event handlers
local lEventHandler = {};

MobHealth_ShowAsPercent = nil;
MobHealth_ShowPercentIfBoss = nil;

MOB_HEALTH_COLOR_BLUE	= "|c009090FF";
MOB_HEALTH_COLOR_WHITE	= "|c00FFFFFF";

if (GetLocale() == "zhCN") then
	MOD_MOB_HEALTH_TITLE = "怪物生命";
	MOB_HEALTH_ENABLE_TEXT = "显示怪物生命值";
	MOB_HEALTH_SHOW_BOSS_AS_PRECENT_TEXT = "目标为世界级首领时显示百分比";
	MOB_HEALTH_SHOW_AS_PERCENT_TEXT = "显示怪物血量的百分比";

	MOB_HEALTH_TITLE = "|c003060FF[怪物血量]"..MOB_HEALTH_COLOR_WHITE;
	MOB_HEALTH_POS_SET = " 位置设置为：";
	MOB_HEALTH_RESET = " 正在重置数据库";
	MOB_HEALTH_RESET_CERTAIN = " 重置%s的数据";
	MOB_HEALTH_NO_TARGET_DB_FOUND = " 没有在数据库中发现该目标的血量信息。";

	MOB_HEALTH_CMD1 = "你需要指定位置：/mobhealth2 pos [位置]";
	MOB_HEALTH_CMD2 = " 用稳定的最大血量显示";
	MOB_HEALTH_CMD3 = " 用非稳定最大血量显示";
	MOB_HEALTH_CMD4 = " 命令：";
	MOB_HEALTH_CMD5 = "  /mobhealth2 pos [位置]";
	MOB_HEALTH_CMD6 = "    设置位置为[坐标]";
	MOB_HEALTH_CMD7 = "    (相对于目标框，缺省是22，也可以为负数)";
	MOB_HEALTH_CMD8 = "  /mobhealth2 stablemax";
	MOB_HEALTH_CMD9 = "    较少频率更新怪物的最大血量(仅仅在第一次与怪物的";
	MOB_HEALTH_CMD10 = "    战斗中)";
	MOB_HEALTH_CMD11 = "  /mobhealth2 unstablemax";
	MOB_HEALTH_CMD12 = "    总是更新最大怪物血量";
	MOB_HEALTH_CMD13 = "  /mobhealth2 reset all";
	MOB_HEALTH_CMD14 = "    清除整个数据库！";
	MOB_HEALTH_CMD15 = "  /mobhealth2 reset/del/delete/rem/remove/clear";
	MOB_HEALTH_CMD16 = "    清除当前怪物的血量信息";
elseif (GetLocale() == "zhTW") then
	MOD_MOB_HEALTH_TITLE = "怪物生命";
	MOB_HEALTH_ENABLE_TEXT = "顯示怪物生命值";
	MOB_HEALTH_SHOW_BOSS_AS_PRECENT_TEXT = "目標爲世界級首領時顯示百分比";
	MOB_HEALTH_SHOW_AS_PERCENT_TEXT = "顯示怪物血量的百分比";

	MOB_HEALTH_TITLE = "|c003060FF[怪物血量]"..MOB_HEALTH_COLOR_WHITE;
	MOB_HEALTH_POS_SET = " 位置設置爲：";
	MOB_HEALTH_RESET = " 正在重置數據庫";
	MOB_HEALTH_RESET_CERTAIN = " 重置%s的數據";
	MOB_HEALTH_NO_TARGET_DB_FOUND = " 沒有在數據庫中發現該目標的血量信息。";

	MOB_HEALTH_CMD1 = "你需要指定位置：/mobhealth2 pos [位置]";
	MOB_HEALTH_CMD2 = " 用穩定的最大血量顯示";
	MOB_HEALTH_CMD3 = " 用非穩定最大血量顯示";
	MOB_HEALTH_CMD4 = " 命令：";
	MOB_HEALTH_CMD5 = "  /mobhealth2 pos [位置]";
	MOB_HEALTH_CMD6 = "    設置位置爲[坐標]";
	MOB_HEALTH_CMD7 = "    (相對于目標框，缺省是22，也可以爲負數)";
	MOB_HEALTH_CMD8 = "  /mobhealth2 stablemax";
	MOB_HEALTH_CMD9 = "    較少頻率更新怪物的最大血量(僅僅在第一次與怪物的";
	MOB_HEALTH_CMD10 = "    戰鬥中)";
	MOB_HEALTH_CMD11 = "  /mobhealth2 unstablemax";
	MOB_HEALTH_CMD12 = "    總是更新最大怪物血量";
	MOB_HEALTH_CMD13 = "  /mobhealth2 reset all";
	MOB_HEALTH_CMD14 = "    清除整個數據庫！";
	MOB_HEALTH_CMD15 = "  /mobhealth2 reset/del/delete/rem/remove/clear";
	MOB_HEALTH_CMD16 = "    清除當前怪物的血量信息";
else
	MOD_MOB_HEALTH_TITLE = "Mob Health";
	MOB_HEALTH_ENABLE_TEXT = "Show Mob Health";
	MOB_HEALTH_SHOW_BOSS_AS_PRECENT_TEXT = "Show Percentage if meet world class boss";
	MOB_HEALTH_SHOW_AS_PERCENT_TEXT = "Show Percentage";

	MOB_HEALTH_TITLE = "|c003060FFMobHealth2"..MOB_HEALTH_COLOR_WHITE;
	MOB_HEALTH_POS_SET = " position set to ";
	MOB_HEALTH_RESET = " reseting database";
	MOB_HEALTH_RESET_CERTAIN = " reseting data for %s";
	MOB_HEALTH_NO_TARGET_DB_FOUND = " no target with hp information in DB found.";

	MOB_HEALTH_CMD1 = "You need to specify position: /mobhealth2 pos [position]";
	MOB_HEALTH_CMD2 = " using stable max HP display";
	MOB_HEALTH_CMD3 = " using unstable max HP display";
	MOB_HEALTH_CMD4 = " commands:";
	MOB_HEALTH_CMD5 = "  /mobhealth2 pos [position]";
	MOB_HEALTH_CMD6 = "    set position to [position]";
	MOB_HEALTH_CMD7 = "    (relative to target frame, default 22, negatives also work)";
	MOB_HEALTH_CMD8 = "  /mobhealth2 stablemax";
	MOB_HEALTH_CMD9 = "    updates Max mob HP less often (only in first battle with mob";
	MOB_HEALTH_CMD10 = "    and between battles)";
	MOB_HEALTH_CMD11 = "  /mobhealth2 unstablemax";
	MOB_HEALTH_CMD12 = "    always updates Max mob HP";
	MOB_HEALTH_CMD13 = "  /mobhealth2 reset all";
	MOB_HEALTH_CMD14 = "    clears whole database!";
	MOB_HEALTH_CMD15 = "  /mobhealth2 reset/del/delete/rem/remove/clear";
	MOB_HEALTH_CMD16 = "    clear data for current target";
end
--------------------------------------------------------------------------------------------------
-- 扩展接口 Zeg 2006-3-24 ngacn.com
-- 执行MobHealthRegister(from,func)注册消息处理函数
-- 在MobHealth更新HP显示的时候消息处理函数会收到同样的值
-- 执行MobHealthUnregister(from)取消注册
-- 参数说明
-- MobHealthRegister(from,func)
-- from为注册源（字符串）一般来说用你自己插件的名字
-- func为消息处理函数 该函数有一个参数 其值为MobHealth显示的HP值
-- 举例
--[[

--定义消息处理函数
msghandlers = function(disp_hp)
DEFAULT_CHAT_FRAME:AddMessage(disp_hp);
end
--注册
MobHealthRegister('SomeAddon',msghandlers);

]]
--------------------------------------------------------------------------------------------------

MobHealth_reg = {};

function MobHealthRegister(from,func)
	if not(MobHealth_reg['from']) then
		MobHealth_reg['from'] = func;
	end
end

function MobHealthUnregister(from)
	if (MobHealth_reg['from']) then
		MobHealth_reg['from'] = nil;
	end
end

--------------------------------------------------------------------------------------------------
-- external functions for macros / scripts
--   - return value:
--     * (current hp or max hp) if a mob is selected and it's health is known
--     * 0 otherwise
--------------------------------------------------------------------------------------------------

function MobHealth_GetTargetCurHP()
	if ( lTargetData ) then
		return math.floor(lTargetData.currentHealthPercent * lTargetData.PPP + 0.5);
	end	
end

function MobHealth_GetTargetMaxHP()
	if ( lTargetData ) then
		return math.floor(100 * lTargetData.PPP + 0.5);
	end		
end

--------------------------------------------------------------------------------------------------
-- external functions for macros / scripts
--   - return value:
--     curHP, maxHP = MobHealth_GetUnitHP(unit)
--     curHP and maxHP equal 0 if unknown
--     (for unit = "target" or unit = "mouseover" etc.)
--     (please use MobHealth_GetTargetCurHP / MaxHP if you are always intrested in unit="target"
--     (they are faster)
--------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------
-- Internal functions
--   - all MobHealthDB access functions are left intact for compatiblity
--   - MobHealth is no longer local (but it's not a recomended way to access mob health - even tho
--     it's better than using MobHealthDB directly)
--------------------------------------------------------------------------------------------------

function MobHealth_PPP(index)
	if ( index and MobHealthDB[index] ) then
		local s, e;
		local pts;
		local pct;
		
		s, e, pts, pct = string.find(MobHealthDB[index], "^(%d+)/(%d+)$");
		if ( pts and pct ) then
			pts = pts + 0;
			pct = pct + 0;
			if ( pct ~= 0 ) then
				return pts / pct;
			end
		end
	end
	return 0;
end

local function MobHealth_Pts(index)
	if ( index and MobHealthDB[index] ) then
		local s, e;
		local val;
		
		s, e, val = string.find(MobHealthDB[index], "^(%d+)/");
		
		if ( val ) then
			return val + 0;
		end
	end
	return 0;
end

local function MobHealth_Pct(index)
	if ( index and MobHealthDB[index] ) then
		local s, e;
		local val;
		
		s, e, val = string.find(MobHealthDB[index], "/(%d+)$");
		
		if ( val ) then
			return val + 0;
		end
	end
	return 0;
end

local function MobHealth_Set(index, pts, pct)
	if ( index ) then
		if ( pts ) then
			pts = pts + 0;
		else
			pts = 0;
		end
		if ( pct ) then
			pct = pct + 0;
		else
			pct = 0;
		end
		if ( pts == 0 and pct == 0 ) then
			MobHealthDB[index] = nil;
		else
			MobHealthDB[index] = pts.."/"..pct;
		end
	end
end



local function MobHealthPlayer_Pts(index)
	if ( index and MobHealthPlayerDB[index] ) then
		local s, e;
		local val;
		
		s, e, val = string.find(MobHealthPlayerDB[index], "^(%d+)/");
		
		if ( val ) then
			return val + 0;
		end
	end
	return 0;
end

local function MobHealthPlayer_Pct(index)
	if ( index and MobHealthPlayerDB[index] ) then
		local s, e;
		local val;
		
		s, e, val = string.find(MobHealthPlayerDB[index], "/(%d+)$");
		
		if ( val ) then
			return val + 0;
		end
	end
	return 0;
end

local function MobHealthPlayer_Set(index, pts, pct)
	if ( index ) then
		if ( pts ) then
			pts = pts + 0;
		else
			pts = 0;
		end
		if ( pct ) then
			pct = pct + 0;
		else
			pct = 0;
		end
		if ( pts == 0 and pct == 0 ) then
			MobHealthPlayerDB[index] = nil;
		else
			MobHealthPlayerDB[index] = pts.."/"..pct;
		end
	end
end

local function MobHealth_Display(currentPct, index)
	local field = getglobal("MobHealthText");
	local text = "";
	
	if ( field ) then
		if (MobHealth_ShowPercentIfBoss == 1 and UnitClassification("target") == "worldboss") then
			if (not UnitIsDead("target")) then
				text = UnitHealth("target") .. " %";
			end
		elseif (MobHealth_ShowAsPercent == 1 and (currentPct or index)) then
			if (not UnitIsDead("target")) then
				text = UnitHealth("target") .. " %";
			end
		elseif ( lTargetData and lTargetData.PPP > 0 ) then
			local maxhp;
			if (not MobHealthConfig["unstablemax"] and lTargetData.maxHP) then
				maxhp = lTargetData.maxHP;
			else
				maxhp = (100 * lTargetData.PPP) + 0.5;
			end
			if ( currentPct ) then
				text = string.format("%d / %d", (currentPct * lTargetData.PPP) + 0.5, maxhp);
			else
				text = string.format("??? / %d", maxhp);
			end
		end
		field:SetText(text);
		for from,func in pairs(MobHealth_reg) do
			func(text);
		end
	end
end



local function MobHealth_SetPos(pos)
	MobHealthFrame:SetPoint("TOP", "TargetFrameHealthBar", "BOTTOM", -2, tonumber(pos) );
	DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_POS_SET..pos);
end

local function MobHealth_VariablesLoaded()
	if (not MobHealthDB ) then
		MobHealthDB = { };
	else
		local index, value;
		
		for index, value in MobHealthDB do
			-- Convert the old-style data into the newer, more compact form
			if( type(value) == "table" ) then
				MobHealth_Set(index, value.damPts, value.damPct);
			end
		end
	end
	
	if (not MobHealthConfig ) then
		MobHealthConfig = {};
	elseif (MobHealthConfig["position"]) then
		MobHealth_SetPos(MobHealthConfig["position"]);
	end

	if (not MobHealthPlayerDB) then
		MobHealthPlayerDB = {};
	end

end

local function MobHealth_Reset()
	DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_RESET);
	MobHealthDB = {};
	MobHealthConfig = {};
	MobHealthPlayerDB = {}; -- this is not saved variable
end

local function MobHealth_ClearTargetData()
	if (lTargetData) then
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..string.format(MOB_HEALTH_RESET_CERTAIN, lTargetData.index));
		lTargetData.PPP = 0;
		lTargetData.firstBattle = true;
		lTargetData.totalDamagePoints = 0;
		lTargetData.totalChangeHP = 0;
		lTargetData.maxHP = nil;

		MobHealth_Display(nil, nil);

		if (lTargetData.mob) then
			MobHealthDB[lTargetData.index] = nil;
		else
			MobHealthPlayerDB[lTargetData.index] = nil;
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_NO_TARGET_DB_FOUND);
	end

end


function MobHealth_CMD(msg)
	local _, _, cmd, arg1 = string.find(msg, "(%w+)[ ]?([-%w]*)"); 

	if (cmd == "pos") then
		if (arg1 ~= "") then
			MobHealthConfig["position"] = arg1;
			MobHealth_SetPos(arg1);
		else
			DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_CMD1);
		end
	elseif (cmd == "stablemax") then
		MobHealthConfig["unstablemax"] = nil;
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_CMD2);
	elseif (cmd == "unstablemax") then
		MobHealthConfig["unstablemax"] = true;
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_CMD3);
	elseif (cmd == "reset" and arg1 == "all") then
		MobHealth_Reset();
	elseif (cmd == "reset" or cmd == "del" or cmd == "delete" or cmd == "rem" or cmd == "remove" or cmd == "clear") then
		MobHealth_ClearTargetData();
	else
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_TITLE..MOB_HEALTH_CMD4);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_BLUE..MOB_HEALTH_CMD5);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD6);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD7);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_BLUE..MOB_HEALTH_CMD8);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD9);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD10);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_BLUE..MOB_HEALTH_CMD11);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD12);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_BLUE..MOB_HEALTH_CMD13);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD14);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_BLUE..MOB_HEALTH_CMD15);
		DEFAULT_CHAT_FRAME:AddMessage(MOB_HEALTH_COLOR_WHITE..MOB_HEALTH_CMD16);
	end
end

function MobHealth_SaveTargetData()
	if (lTargetData) then
		if( lTargetData.PPP > 0 and lTargetData.totalChangeHP < 10000 ) then
			if (lTargetData.mob) then
				MobHealth_Set(lTargetData.index, lTargetData.totalDamagePoints, lTargetData.totalChangeHP);
			else
				MobHealthPlayer_Set(lTargetData.index, lTargetData.totalDamagePoints, lTargetData.totalChangeHP);
			end
		end
	end	
end

--------------------------------------------------------------------------------------------------
-- OnFoo functions
--------------------------------------------------------------------------------------------------
function MobHealth_Toggle(arg)
	if (arg == 1) then
		for key,value in lEventHandler do
			MobHealthFrame:RegisterEvent(key);
		end
	else
		for key,value in lEventHandler do
			MobHealthFrame:UnregisterEvent(key);
		end
	end
end

function MobHealth_OnLoad()
	SlashCmdList["MOBHEALTH2"] = MobHealth_CMD;

	SLASH_MOBHEALTH21 = "/mobhealth2";

	ModManagement_RegisterMod(
		"MobHealth",
		"Interface\\Icons\\Spell_Shadow_BloodBoil",
		MOD_MOB_HEALTH_TITLE,
		"",
		nil
	);
	
	ModManagement_RegisterCheckBox(
		"MobHealth",
		MOB_HEALTH_ENABLE_TEXT,
		nil,
		"MobHealthEnable",
		1,
		function (arg)
			MobHealth_Toggle(arg);
		end
	);

	ModManagement_RegisterCheckBox(
		"MobHealth",
		MOB_HEALTH_SHOW_BOSS_AS_PRECENT_TEXT,
		nil,
		"MobHealthShowBossAsPrecent",
		1,
		function (arg)
			MobHealth_ShowPercentIfBoss = arg;
		end
	);

	ModManagement_RegisterCheckBox(
		"MobHealth",
		MOB_HEALTH_SHOW_AS_PERCENT_TEXT,
		nil,
		"MobHealthShowPercent",
		0,
		function (arg)
			MobHealth_ShowAsPercent = arg;
		end
	);				
	
	this:RegisterEvent("VARIABLES_LOADED");
end

function MobHealth_OnEvent(event)
	-- DEFAULT_CHAT_FRAME:AddMessage("Event: "..event)
	if (lEventHandler[event]) then
		lEventHandler[event](arg1, arg2, arg3, arg4);
	end
end

--------------------------------------------------------------------------------------------------
-- Event handlers
--------------------------------------------------------------------------------------------------

lEventHandler["VARIABLES_LOADED"] = function ()
	MobHealth_VariablesLoaded();
end

lEventHandler["UNIT_HEALTH"] = function ()
	if (arg1 == "target") then
		MobHealth_Display(nil, nil);
		if( lTargetData ) then
			local health = UnitHealth("target");
			if( health and health ~= 0 ) then
				local change = lTargetData.currentHealthPercent - health;
				local damage = lTargetData.tempDamagePoints;
				if( change > 0 and damage > 0 ) then
					lTargetData.totalDamagePoints = lTargetData.totalDamagePoints + damage;
					lTargetData.totalChangeHP = lTargetData.totalChangeHP + change;

					if( lTargetData.totalChangeHP ~= 0 and lTargetData.totalDamagePoints ~= 0 ) then
						lTargetData.PPP = lTargetData.totalDamagePoints / lTargetData.totalChangeHP;
					end

					if (lTargetData.firstBattle) then
						-- this is needed for other addons reading directly from DB
						MobHealth_SaveTargetData()
					end

					lTargetData.tempDamagePoints = 0;

				elseif ( change ~= 0 ) then -- could be negative so let's be safe
					lTargetData.tempDamagePoints = 0;
				end

				lTargetData.currentHealthPercent = health;

				MobHealth_Display(health, lTargetData.index);
			end
		end
	end
end

lEventHandler["UNIT_COMBAT"] = function ()
	if( lTargetData and arg1 == "target" ) then
		lTargetData.tempDamagePoints = lTargetData.tempDamagePoints + arg4;
	end
end

lEventHandler["PLAYER_TARGET_CHANGED"] = function ()
	if (lTargetData) then
		-- we have old target, so we should update it's HP in database
		MobHealth_SaveTargetData();
	end

	local name = UnitName("target");
	if( name ) then
		if( UnitCanAttack("player", "target") and not UnitIsDead("target") and not UnitIsFriend("player", "target") ) then
			-- Attackable, alive, non-player target
			lTargetData = { };
			lTargetData.name = name;
			lTargetData.level = UnitLevel("target");
			lTargetData.currentHealthPercent = UnitHealth("target");
			lTargetData.tempDamagePoints = 0;

			if (UnitIsPlayer("target") ) then
				lTargetData.player = true;
				lTargetData.index = lTargetData.name;
				lTargetData.totalDamagePoints = MobHealthPlayer_Pts(lTargetData.index);
				lTargetData.totalChangeHP = MobHealthPlayer_Pct(lTargetData.index);
			else
				lTargetData.mob = true;
				lTargetData.index = lTargetData.name..":"..lTargetData.level;
				lTargetData.totalDamagePoints = MobHealth_Pts(lTargetData.index);
				lTargetData.totalChangeHP = MobHealth_Pct(lTargetData.index);
			end

			
			if( lTargetData.totalChangeHP ~= 0 and lTargetData.totalDamagePoints ~= 0 ) then
				lTargetData.PPP = lTargetData.totalDamagePoints / lTargetData.totalChangeHP;
			else
				lTargetData.PPP = 0;
			end

			if (lTargetData.totalChangeHP == 0) then
				-- first battle with mob/player
				lTargetData.firstBattle = true;
			else
				lTargetData.maxHP = math.floor(lTargetData.PPP * 100 + 0.5);
			end

			MobHealth_Display(lTargetData.currentHealthPercent, lTargetData.index);
			return;
		end
	end

	-- Unusable target
	lTargetData = nil;

	MobHealth_Display(nil, nil);
end